<?php
namespace Teknisa\CMP\Modules\Solicitacao\Modules\Relatorios\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp06600LogDeSolicitacaoDeComprasController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection) {

        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
    }

    protected $reportMapping = array (
        
        'Cmp06600' =>
            array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                "OPERADOR"      => "L_OPERADOR",    //nessa parte, são passados os nomes dos campos que o backend pretende receber e os que estamos enviando. É feita uma "conversão/adaptação"
                "FILIAL"        => "L_FILIAL",
                "DTINI"         => "P_DTI",
                "DTFIM"         => "P_DTF",
                "DATAINIC"      => "P_DATAINIC",
                "DATAFINA"      => "P_DATAFINA"
            )
        )
    );
    
    
    public function insertLista($nrlista) {
        
    	$params = array(
    		"NRLISTA" => $nrlista,
    		"CDLISTA" => $this->environment->getCdOperador()
    	);
    	
    	$sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
    }
   
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
        $NRLISTA = $this->newCode->getCodeByTableName('NRLISTA', $this->environment->getNrorgTrab(), 1, 10, false);
        
        $row = $request->getRow();

        // $this ->insertLista($NRLISTA);
        $row['__report_name'] = 'Cmp06600';
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        
    }
}